"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function wrap(code) {
    return '!(function () {' + code + '})();';
}
function default_1(compiler, next) {
    compiler.shims.push(wrap(compiler.getHeader()));
    if (compiler.options.resources.length) {
        compiler.shims.push(wrap("\"use strict\";\nObject.defineProperty(exports, \"__esModule\", { value: true });\nvar assert_1 = require(\"assert\");\nvar path_1 = require(\"path\");\nvar binary = process.__nexe;\nassert_1.ok(binary);\nvar manifest = binary.resources;\nvar isString = function (x) { return typeof x === 'string' || x instanceof String; };\nif (Object.keys(manifest).length) {\n    var fs_1 = require('fs');\n    var originalReadFile_1 = fs_1.readFile;\n    var originalReadFileSync_1 = fs_1.readFileSync;\n    var resourceStart_1 = binary.layout.resourceStart;\n    var setupManifest_1 = function () {\n        var manifest = binary.resources;\n        Object.keys(manifest).forEach(function (key) {\n            var absolutePath = path_1.resolve(key);\n            if (!manifest[absolutePath]) {\n                manifest[absolutePath] = manifest[key];\n            }\n            var normalizedPath = path_1.normalize(key);\n            if (!manifest[normalizedPath]) {\n                manifest[normalizedPath] = manifest[key];\n            }\n        });\n        setupManifest_1 = function () { };\n    };\n    //TODO track inflight fs reqs??\n    var nfs = {\n        readFile: function readFile(file, options, callback) {\n            setupManifest_1();\n            var entry = manifest[file];\n            if (!entry || !isString(file)) {\n                return originalReadFile_1.apply(fs_1, arguments);\n            }\n            var offset = entry[0], length = entry[1];\n            var resourceOffset = resourceStart_1 + offset;\n            var encoding = isString(options) ? options : null;\n            callback = typeof options === 'function' ? options : callback;\n            fs_1.open(process.execPath, 'r', function (err, fd) {\n                if (err)\n                    return callback(err, null);\n                fs_1.read(fd, Buffer.alloc(length), 0, length, resourceOffset, function (error, bytesRead, result) {\n                    if (error) {\n                        return fs_1.close(fd, function () {\n                            callback(error, null);\n                        });\n                    }\n                    fs_1.close(fd, function (err) {\n                        if (err) {\n                            return callback(err, result);\n                        }\n                        callback(err, encoding ? result.toString(encoding) : result);\n                    });\n                });\n            });\n        },\n        readFileSync: function readFileSync(file, options) {\n            setupManifest_1();\n            var entry = manifest[file];\n            if (!entry || !isString(file)) {\n                return originalReadFileSync_1.apply(fs_1, arguments);\n            }\n            var offset = entry[0], length = entry[1];\n            var resourceOffset = resourceStart_1 + offset;\n            var encoding = isString(options) ? options : null;\n            var fd = fs_1.openSync(process.execPath, 'r');\n            var result = Buffer.alloc(length);\n            fs_1.readSync(fd, result, 0, length, resourceOffset);\n            fs_1.closeSync(fd);\n            return encoding ? result.toString(encoding) : result;\n        }\n    };\n    Object.assign(fs_1, nfs);\n}\n"));
    }
    if (compiler.options.fakeArgv) {
        var nty = !process.stdin.isTTY;
        var input = nty ? '[stdin]' : compiler.options.input;
        compiler.shims.push(wrap("\n      var r = require('path').resolve; \n      process.argv.splice(1,0, " + (nty ? "'" + input + "'" : "r(\"" + input + "\")") + ");"));
    }
    return next();
}
exports.default = default_1;
